<!DOCTYPE html>
<!--html5-->
<!--[if IE 8]>    <html class="no-js lt-ie9" lang="en"> <![endif]-->
<!--[if gt IE 8]><!-->
<html class=" js no-touch boxshadow opacity fontface svg inlinesvg svgclippaths no-ie8compat" style="" lang="en"><!--<![endif]--><head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8">
	<meta http-equiv="X-UA-Compatible" content="IE=edge">
  	<meta charset="utf-8">

	<title>Arduino - SPI </title>
	<link rel="shortcut icon" type="image/x-icon" href="https://www.arduino.cc/en/favicon.png">

	<script src="Arduino%20-%20SPI_files/analytics"></script><script id="facebook-jssdk" src="Arduino%20-%20SPI_files/sdk.js"></script><script async="" src="Arduino%20-%20SPI_files/fbevents.js"></script><script type="text/javascript" async="" src="Arduino%20-%20SPI_files/ga.js"></script><script src="Arduino%20-%20SPI_files/analytics"></script><script src="Arduino%20-%20SPI_files/analytics"></script><script src="Arduino%20-%20SPI_files/jquery-1.js"></script>

	<link rel="stylesheet" href="Arduino%20-%20SPI_files/galleria.css" id="galleria-theme"><link rel="stylesheet" href="Arduino%20-%20SPI_files/fonts.css" type="text/css">
	<link rel="stylesheet" href="Arduino%20-%20SPI_files/arduino-icons.css">
	<link rel="stylesheet" href="Arduino%20-%20SPI_files/animation.css"><!--[if IE 7]>
	<link rel="stylesheet" href="//arduino.cc/css/arduino-icons-ie7.css"><![endif]-->
	<!--[if gte IE 9]><!-->
	<link rel="stylesheet" href="Arduino%20-%20SPI_files/foundation2.css" type="text/css">
	<!--<![endif]-->
	<!--[if IE 8]>
		<link rel='stylesheet' href='//arduino.cc/css/foundation_ie8.css' type='text/css' />
	<![endif]-->
	<link rel="stylesheet" href="Arduino%20-%20SPI_files/arduino_code_highlight.css" type="text/css">
	<link rel="stylesheet" type="text/css" media="screen" href="Arduino%20-%20SPI_files/typeplate.css">
	<link rel="stylesheet" href="Arduino%20-%20SPI_files/arduinoWide_SSO.css" type="text/css">

	<link rel="stylesheet" href="Arduino%20-%20SPI_files/common.css" type="text/css">
	<link rel="stylesheet" href="Arduino%20-%20SPI_files/download_page.css">
	<link href="https://plus.google.com/114839908922424087554" rel="publisher">

	<!-- embedded JS and CSS from PmWiki plugins -->	
	<!--HeaderText--><style type="text/css"><!--
  ul, ol, pre, dl, p { margin-top:0px; margin-bottom:0px; }
  code { white-space: nowrap; }
  .vspace { margin-top:1.33em; }
  .indent { margin-left:40px; }
  .outdent { margin-left:40px; text-indent:-40px; }
  a.createlinktext { text-decoration:none; border-bottom:1px dotted gray; }
  a.createlink { text-decoration:none; position:relative; top:-0.5em;
    font-weight:bold; font-size:smaller; border-bottom:none; }
  img { border:0px; }
  
span.anchor {
	float: left;
	font-size: 10px;
	margin-left: -10px;
	width: 10px;
    position:relative; top:-0.1em;
	text-align: center;
}
span.anchor a { text-decoration: none; }
span.anchor a:hover { text-decoration: underline; }
ol.toc { text-indent:-20px; list-style: none; }
ol.toc ol.toc { text-indent:-40px; }
div.tocfloat { font-size: smaller; margin-bottom: 10px;
    border-top: 1px dotted #555555; border-bottom: 1px dotted #555555;
    padding-top: 5px; padding-bottom: 5px; 
    width: 38%; float: right; margin-left: 10px; clear: right;
    margin-right:-13px; padding-right: 13px; padding-left: 13px;
    background-color: #eeeeee; }
div.toc { font-size: smaller; 
    padding: 5px; border: 1px dotted #cccccc;
    background: #f7f7f7;
    margin-bottom: 10px; }
div.toc p { background-color: #f9f6d6;
    margin-top:-5px;   padding-top: 5px;
    margin-left:-5px;  padding-left: 5px;
    margin-right:-5px; padding-right: 5px;
    padding-bottom: 3px;
    border-bottom:  1px dotted #cccccc; }.editconflict { color:green; 
  font-style:italic; margin-top:1.33em; margin-bottom:1.33em; }

  table.markup { border: 2px dotted #ccf; width:90%; }
  td.markup1, td.markup2 { padding-left:10px; padding-right:10px; }
  td.markup1 { border-bottom: 1px solid #ccf; }
  div.faq { margin-left:2em; }
  div.faq p.question { margin: 1em 0 0.75em -2em; font-weight:bold; }
  div.faq hr { margin-left: -2em; }
   
    .frame 
      { border:1px solid #cccccc; padding:4px; background-color:#f9f9f9; }
    .lfloat { float:left; margin-right:0.5em; }
    .rfloat { float:right; margin-left:0.5em; }
a.varlink { text-decoration:none; }

--></style><script type="text/javascript">
function toggle(obj) {
    var elstyle = document.getElementById(obj).style;
    var text    = document.getElementById(obj + "tog");
    if (elstyle.display == 'none') {
        elstyle.display = 'block';
        text.innerHTML = "hide";
    } else {
        elstyle.display = 'none';
        text.innerHTML = "show";
    }
}
</script><script src="Arduino%20-%20SPI_files/galleria-1.js"></script><script type="text/javascript">Galleria.loadTheme("//www.arduino.cc/en/pub/galleria/themes/classic/galleria.classic.min.js");</script><script src="Arduino%20-%20SPI_files/galleria.js" async="async"></script>  <meta name="robots" content="index,follow">


	<script src="Arduino%20-%20SPI_files/custom.js"></script>

	<!-- do not remove none of those lines, comments embedding in pages will break! -->
	<script src="Arduino%20-%20SPI_files/jquery-ui.js" type="text/javascript"></script>
	<script src="Arduino%20-%20SPI_files/newsletter_subscribe_popup.js" type="text/javascript"></script>
	<script src="Arduino%20-%20SPI_files/checkout.js" type="text/javascript"></script>
	<script src="Arduino%20-%20SPI_files/software_download.js" type="text/javascript"></script><!-- keep https! -->
	<link rel="stylesheet" href="Arduino%20-%20SPI_files/jquery-ui.css" type="text/css">
<style type="text/css">.fb_hidden{position:absolute;top:-10000px;z-index:10001}.fb_reposition{overflow:hidden;position:relative}.fb_invisible{display:none}.fb_reset{background:none;border:0;border-spacing:0;color:#000;cursor:auto;direction:ltr;font-family:"lucida grande", tahoma, verdana, arial, sans-serif;font-size:11px;font-style:normal;font-variant:normal;font-weight:normal;letter-spacing:normal;line-height:1;margin:0;overflow:visible;padding:0;text-align:left;text-decoration:none;text-indent:0;text-shadow:none;text-transform:none;visibility:visible;white-space:normal;word-spacing:normal}.fb_reset>div{overflow:hidden}.fb_link img{border:none}@keyframes fb_transform{from{opacity:0;transform:scale(.95)}to{opacity:1;transform:scale(1)}}.fb_animate{animation:fb_transform .3s forwards}
.fb_dialog{background:rgba(82, 82, 82, .7);position:absolute;top:-10000px;z-index:10001}.fb_reset .fb_dialog_legacy{overflow:visible}.fb_dialog_advanced{padding:10px;-moz-border-radius:8px;-webkit-border-radius:8px;border-radius:8px}.fb_dialog_content{background:#fff;color:#333}.fb_dialog_close_icon{background:url(https://static.xx.fbcdn.net/rsrc.php/v3/yq/r/IE9JII6Z1Ys.png) no-repeat scroll 0 0 transparent;_background-image:url(https://static.xx.fbcdn.net/rsrc.php/v3/yL/r/s816eWC-2sl.gif);cursor:pointer;display:block;height:15px;position:absolute;right:18px;top:17px;width:15px}.fb_dialog_mobile .fb_dialog_close_icon{top:5px;left:5px;right:auto}.fb_dialog_padding{background-color:transparent;position:absolute;width:1px;z-index:-1}.fb_dialog_close_icon:hover{background:url(https://static.xx.fbcdn.net/rsrc.php/v3/yq/r/IE9JII6Z1Ys.png) no-repeat scroll 0 -15px transparent;_background-image:url(https://static.xx.fbcdn.net/rsrc.php/v3/yL/r/s816eWC-2sl.gif)}.fb_dialog_close_icon:active{background:url(https://static.xx.fbcdn.net/rsrc.php/v3/yq/r/IE9JII6Z1Ys.png) no-repeat scroll 0 -30px transparent;_background-image:url(https://static.xx.fbcdn.net/rsrc.php/v3/yL/r/s816eWC-2sl.gif)}.fb_dialog_loader{background-color:#f6f7f9;border:1px solid #606060;font-size:24px;padding:20px}.fb_dialog_top_left,.fb_dialog_top_right,.fb_dialog_bottom_left,.fb_dialog_bottom_right{height:10px;width:10px;overflow:hidden;position:absolute}.fb_dialog_top_left{background:url(https://static.xx.fbcdn.net/rsrc.php/v3/ye/r/8YeTNIlTZjm.png) no-repeat 0 0;left:-10px;top:-10px}.fb_dialog_top_right{background:url(https://static.xx.fbcdn.net/rsrc.php/v3/ye/r/8YeTNIlTZjm.png) no-repeat 0 -10px;right:-10px;top:-10px}.fb_dialog_bottom_left{background:url(https://static.xx.fbcdn.net/rsrc.php/v3/ye/r/8YeTNIlTZjm.png) no-repeat 0 -20px;bottom:-10px;left:-10px}.fb_dialog_bottom_right{background:url(https://static.xx.fbcdn.net/rsrc.php/v3/ye/r/8YeTNIlTZjm.png) no-repeat 0 -30px;right:-10px;bottom:-10px}.fb_dialog_vert_left,.fb_dialog_vert_right,.fb_dialog_horiz_top,.fb_dialog_horiz_bottom{position:absolute;background:#525252;filter:alpha(opacity=70);opacity:.7}.fb_dialog_vert_left,.fb_dialog_vert_right{width:10px;height:100%}.fb_dialog_vert_left{margin-left:-10px}.fb_dialog_vert_right{right:0;margin-right:-10px}.fb_dialog_horiz_top,.fb_dialog_horiz_bottom{width:100%;height:10px}.fb_dialog_horiz_top{margin-top:-10px}.fb_dialog_horiz_bottom{bottom:0;margin-bottom:-10px}.fb_dialog_iframe{line-height:0}.fb_dialog_content .dialog_title{background:#6d84b4;border:1px solid #365899;color:#fff;font-size:14px;font-weight:bold;margin:0}.fb_dialog_content .dialog_title>span{background:url(https://static.xx.fbcdn.net/rsrc.php/v3/yd/r/Cou7n-nqK52.gif) no-repeat 5px 50%;float:left;padding:5px 0 7px 26px}body.fb_hidden{-webkit-transform:none;height:100%;margin:0;overflow:visible;position:absolute;top:-10000px;left:0;width:100%}.fb_dialog.fb_dialog_mobile.loading{background:url(https://static.xx.fbcdn.net/rsrc.php/v3/ya/r/3rhSv5V8j3o.gif) white no-repeat 50% 50%;min-height:100%;min-width:100%;overflow:hidden;position:absolute;top:0;z-index:10001}.fb_dialog.fb_dialog_mobile.loading.centered{width:auto;height:auto;min-height:initial;min-width:initial;background:none}.fb_dialog.fb_dialog_mobile.loading.centered #fb_dialog_loader_spinner{width:100%}.fb_dialog.fb_dialog_mobile.loading.centered .fb_dialog_content{background:none}.loading.centered #fb_dialog_loader_close{color:#fff;display:block;padding-top:20px;clear:both;font-size:18px}#fb-root #fb_dialog_ipad_overlay{background:rgba(0, 0, 0, .45);position:absolute;bottom:0;left:0;right:0;top:0;width:100%;min-height:100%;z-index:10000}#fb-root #fb_dialog_ipad_overlay.hidden{display:none}.fb_dialog.fb_dialog_mobile.loading iframe{visibility:hidden}.fb_dialog_content .dialog_header{-webkit-box-shadow:white 0 1px 1px -1px inset;background:-webkit-gradient(linear, 0% 0%, 0% 100%, from(#738ABA), to(#2C4987));border-bottom:1px solid;border-color:#1d4088;color:#fff;font:14px Helvetica, sans-serif;font-weight:bold;text-overflow:ellipsis;text-shadow:rgba(0, 30, 84, .296875) 0 -1px 0;vertical-align:middle;white-space:nowrap}.fb_dialog_content .dialog_header table{-webkit-font-smoothing:subpixel-antialiased;height:43px;width:100%}.fb_dialog_content .dialog_header td.header_left{font-size:12px;padding-left:5px;vertical-align:middle;width:60px}.fb_dialog_content .dialog_header td.header_right{font-size:12px;padding-right:5px;vertical-align:middle;width:60px}.fb_dialog_content .touchable_button{background:-webkit-gradient(linear, 0% 0%, 0% 100%, from(#4966A6), color-stop(.5, #355492), to(#2A4887));border:1px solid #29487d;-webkit-background-clip:padding-box;-webkit-border-radius:3px;-webkit-box-shadow:rgba(0, 0, 0, .117188) 0 1px 1px inset, rgba(255, 255, 255, .167969) 0 1px 0;display:inline-block;margin-top:3px;max-width:85px;line-height:18px;padding:4px 12px;position:relative}.fb_dialog_content .dialog_header .touchable_button input{border:none;background:none;color:#fff;font:12px Helvetica, sans-serif;font-weight:bold;margin:2px -12px;padding:2px 6px 3px 6px;text-shadow:rgba(0, 30, 84, .296875) 0 -1px 0}.fb_dialog_content .dialog_header .header_center{color:#fff;font-size:16px;font-weight:bold;line-height:18px;text-align:center;vertical-align:middle}.fb_dialog_content .dialog_content{background:url(https://static.xx.fbcdn.net/rsrc.php/v3/y9/r/jKEcVPZFk-2.gif) no-repeat 50% 50%;border:1px solid #555;border-bottom:0;border-top:0;height:150px}.fb_dialog_content .dialog_footer{background:#f6f7f9;border:1px solid #555;border-top-color:#ccc;height:40px}#fb_dialog_loader_close{float:left}.fb_dialog.fb_dialog_mobile .fb_dialog_close_button{text-shadow:rgba(0, 30, 84, .296875) 0 -1px 0}.fb_dialog.fb_dialog_mobile .fb_dialog_close_icon{visibility:hidden}#fb_dialog_loader_spinner{animation:rotateSpinner 1.2s linear infinite;background-color:transparent;background-image:url(https://static.xx.fbcdn.net/rsrc.php/v3/yD/r/t-wz8gw1xG1.png);background-repeat:no-repeat;background-position:50% 50%;height:24px;width:24px}@keyframes rotateSpinner{0%{transform:rotate(0deg)}100%{transform:rotate(360deg)}}
.fb_iframe_widget{display:inline-block;position:relative}.fb_iframe_widget span{display:inline-block;position:relative;text-align:justify}.fb_iframe_widget iframe{position:absolute}.fb_iframe_widget_fluid_desktop,.fb_iframe_widget_fluid_desktop span,.fb_iframe_widget_fluid_desktop iframe{max-width:100%}.fb_iframe_widget_fluid_desktop iframe{min-width:220px;position:relative}.fb_iframe_widget_lift{z-index:1}.fb_hide_iframes iframe{position:relative;left:-10000px}.fb_iframe_widget_loader{position:relative;display:inline-block}.fb_iframe_widget_fluid{display:inline}.fb_iframe_widget_fluid span{width:100%}.fb_iframe_widget_loader iframe{min-height:32px;z-index:2;zoom:1}.fb_iframe_widget_loader .FB_Loader{background:url(https://static.xx.fbcdn.net/rsrc.php/v3/y9/r/jKEcVPZFk-2.gif) no-repeat;height:32px;width:32px;margin-left:-16px;position:absolute;left:50%;z-index:4}</style></head>
<body style="padding-top: 40px;">

	<div id="menuWings" class="fixed" style="display: block;"></div>
	<div id="page">
		
		
<script>
	var userAgent = (navigator.userAgent || navigator.vendor || window.opera).toLowerCase();
	if(userAgent.indexOf('mac')>0){
		$("head").append('<style type="text/css">@-moz-document url-prefix() {h1 a, h2 a, h3 a, h4 a, h5 a, h1 a:hover, h2 a:hover, th a, th a:hover, h3 a:hover, h4 a:hover, h5 a:hover, #wikitext h2 a:hover, #wikitext h3 a:hover, #wikitext h4 a:hover {padding-bottom: 0.5em!important;} #pageheader .search input{font-family: "TyponineSans Regular 18";} #pagefooter .monospace{margin-top: -4px;} #navWrapper ul.left &gt; li{margin-top: -2px; padding-bottom: 2px;}#navWrapper ul.right &gt; li{margin-top: -5px; padding-bottom: 5px;}#navWrapper ul.right &gt; li ul{margin-top: 4px;} .slider-container .fixed-caption p{padding:8px 0 14px 0}}</style>');
	}
</script>

<!--[if IE]>
<link rel='stylesheet' href='https://id.arduino.cc//css/ie-monospace.css' type='text/css' />
<![endif]-->

<div id="menuWings" class="fixed"></div>

<!--[if IE 8]>
<div class="alert-box panel ie8alert">
  <p><strong>Arduino.cc offers limited compatibility for Internet Explorer 8. Get a modern browser as Chrome, Firefox or Safari.</strong></p>
  <a href="" class="close">&times;</a>
</div>
<![endif]-->

<div id="pageheader">
	<div class="row">
		<div class="small-6 large-8 eight columns">
			<div class="title"><a href="https://www.arduino.cc/">Arduino</a></div>
		</div>
		<div class="small-6 large-4 four columns search">
			<div class="row collapse">
				<form method="GET" action="//www.google.com/search">
	<div class="small-12 twelve columns">
		<i class="icon-search-2"></i>
		<input name="ie" value="UTF-8" type="hidden">
		<input name="oe" value="UTF-8" type="hidden">
		<input name="q" size="25" maxlength="255" placeholder="Search the Arduino Website" type="text">
		<input name="btnG" value="search" type="submit">
		<input name="domains" value="http://www.arduino.cc" type="hidden">
		<input name="sitesearch" value="http://www.arduino.cc" type="hidden">
	</div>
</form>			</div>
		</div>
	</div>

	<!--[if gte IE 9]><!-->
	<div id="navWrapper" class="sticky fixed">
	<!--<![endif]-->
	<!--[if IE 8]>
		<div id="navWrapper">
	<![endif]-->
		<nav class="top-bar" data-options="is_hover:true">
			<ul class="title-area">
				<li class="name"></li>
			</ul>

			
		<section class="top-bar-section">
				<ul class="left">
					<li class="active" id="navLogo" style="display: block;">
						<a href="https://www.arduino.cc/">
							<img src="Arduino%20-%20SPI_files/logo_46.png" alt="userpicture">
						</a>
					</li>
					<li class="active" id="navHome" style="display: none;"><a href="https://www.arduino.cc/">Home</a></li>
					<li><a href="https://store.arduino.cc/">Buy</a></li>
					<li><a href="https://www.arduino.cc/en/Main/Software">Software</a></li>
					<li class="has-dropdown not-click"><a href="#">Products</a>
						<ul class="dropdown"><li class="title back js-generated"><h5><a href="#"><span class="backArrow">Back</span></a></h5></li>
							<li><a href="https://www.arduino.cc/en/Main/Products">Arduino</a></li>
							<li><a href="https://www.arduino.cc/en/ArduinoAtHeart/Products">AtHeart</a></li>
							<li><a href="https://www.arduino.cc/en/ArduinoCertified/Products">Certified</a></li>
						</ul>
					</li>
					<li class="has-dropdown not-click"><a href="#">Learning</a>
						<ul class="dropdown"><li class="title back js-generated"><h5><a href="#"><span class="backArrow">Back</span></a></h5></li>
							<li><a href="https://www.arduino.cc/en/Guide/HomePage">Getting started</a></li>
							<li><a href="https://www.arduino.cc/en/Tutorial/HomePage">Tutorials</a></li>
							<li><a href="https://www.arduino.cc/en/Reference/HomePage">Reference</a></li>
							<li><a href="https://www.arduino.cc/en/Main/Education">Education</a></li>
							<li><a href="http://playground.arduino.cc/">Playground</a></li>
						</ul>
					</li>
					<li><a href="https://forum.arduino.cc/">Forum</a></li>
					<li class="has-dropdown not-click"><a href="#">Support</a>
						<ul class="dropdown"><li class="title back js-generated"><h5><a href="#"><span class="backArrow">Back</span></a></h5></li>
							<li><a href="https://www.arduino.cc/en/Main/FAQ">FAQ</a></li>
							<li><a href="https://www.arduino.cc/en/ContactUs">Contact Us</a></li>
						</ul>
					</li>
					<li><a href="http://blog.arduino.cc/">Blog</a></li>
				</ul>

								<ul class="right">
					<li><a href="https://id.arduino.cc/auth/login/?returnurl=https%3A%2F%2Fwww.arduino.cc%2Fen%2Freference%2FSPI" class="cart">LOG IN</a></li>
					<li><a href="https://id.arduino.cc/auth/signup" class="cart">SIGN UP</a></li>
				</ul>
							</section></nav>
	</div>
</div>



		<br class="clear">

		<div id="pagetext">
				<!--PageText-->
<div id="wikitext">
<p><strong>Reference</strong> &nbsp;  <a class="wikilink" href="https://www.arduino.cc/en/Reference/HomePage">Language</a> | <a class="wikilink" href="https://www.arduino.cc/en/Reference/Libraries">Libraries</a> | <a class="wikilink" href="https://www.arduino.cc/en/Reference/Comparison">Comparison</a> | <a class="wikilink" href="https://www.arduino.cc/en/Reference/Changes">Changes</a>
</p>
<p class="vspace"></p><h2>SPI library</h2>
<p class="vspace"></p><table><tbody><tr><td valign="top" width="55%">
<p class="vspace"></p><p>This library allows you to communicate with SPI devices, with the Arduino as the master device.  
</p>
<p class="vspace"></p><h3>A Brief Introduction to the Serial Peripheral Interface (SPI)</h3>
<p>Serial Peripheral Interface (SPI) is a synchronous serial data 
protocol used by microcontrollers for communicating with one or more 
peripheral devices quickly over short distances. It can also be used for
 communication between two microcontrollers. 
</p>
<p class="vspace"></p><p>With an SPI connection there is always one 
master device (usually a microcontroller) which controls the peripheral 
devices. Typically there are three lines common to all the devices:
</p><ul><li><strong>MISO</strong> (Master In Slave Out) - The Slave line for sending data to the master, 
</li><li><strong>MOSI</strong> (Master Out Slave In) - The Master line for sending data to the peripherals, 
</li><li><strong>SCK</strong> (Serial Clock) - The clock pulses which synchronize data transmission generated by the master 
</li></ul><p class="vspace"></p><p>and one line specific for every device:
</p><ul><li><strong>SS</strong> (Slave Select) - the pin on each device that the master can use to enable and disable specific devices.
</li></ul><p class="vspace"></p><p>When a device's Slave Select pin is 
low, it communicates with the master.  When it's high, it ignores the 
master.  This allows you to have multiple SPI devices sharing the same 
MISO, MOSI, and CLK lines.
</p>
<p class="vspace"></p><p>To write code for a new SPI device you need to note a few things:
</p><ul><li>What is the maximum SPI speed your device can use? This is controlled by the first parameter in <span class="wikiword">SPISettings</span>.  If you are using a chip rated at 15 <span class="wikiword">MHz</span>, use 15000000.  Arduino will automatically use the best speed that is equal to or less than the number you use with <span class="wikiword">SPISettings</span>.
</li><li>Is data shifted in Most Significant Bit (MSB) or Least Significant Bit (LSB) first? This is controlled by second <span class="wikiword">SPISettings</span> parameter, either MSBFIRST or LSBFIRST. Most SPI chips use MSB first data order.
</li><li>Is the data clock idle when high or low? Are samples on the 
rising or falling edge of clock pulses? These modes are controlled by 
the third parameter in <span class="wikiword">SPISettings</span>.
</li></ul><p class="vspace"></p><p>The SPI standard is loose and each 
device implements it a little differently. This means you have to pay 
special attention to the device's datasheet when writing your  code. 
</p>
<p class="vspace"></p><p>Generally speaking, there are four modes of 
transmission. These modes control whether data is shifted in and out on 
the rising or falling edge of the data clock signal (called the clock <strong>phase</strong>), and whether the clock is idle when high or low (called the clock <strong>polarity</strong>). The four modes combine polarity and phase according to this table:
</p>
<p class="vspace"></p>
<table style="border-collapse:collapse" cellpadding="5" border="1" width="90%"><tbody><tr><td align="center"><strong>Mode</strong></td><td align="center"><strong>Clock Polarity (CPOL)</strong></td><td align="center"><strong>Clock Phase (CPHA)</strong></td><td align="left"><strong>Output Edge</strong></td><td align="left"><strong>Data Capture</strong></td></tr>
<tr><td align="left">SPI_MODE0</td><td align="center">0</td><td align="center">0</td><td>Falling</td><td>Rising</td></tr>
<tr><td align="left">SPI_MODE1</td><td align="center">0</td><td align="center">1</td><td>Rising</td><td>Falling</td></tr>
<tr><td align="left">SPI_MODE2</td><td align="center">1</td><td align="center">0</td><td>Rising</td><td>Falling</td></tr>
<tr><td align="left">SPI_MODE3</td><td align="center">1</td><td align="center">1</td><td>Falling</td><td>Rising</td></tr>
</tbody></table>
<p class="vspace"></p><p>Once you have your SPI parameters, use 
SPI.beginTransaction() to begin using the SPI port.  The SPI port will 
be configured with your all of your settings.  The simplest and most 
efficient way to use <span class="wikiword">SPISettings</span> is directly inside SPI.beginTransaction().
For example:
</p>
<p class="vspace"></p><p><code>SPI.beginTransaction(<span class="wikiword">SPISettings</span>(14000000, MSBFIRST, SPI_MODE0));</code>
</p>
<p class="vspace"></p><p>If other libraries use SPI from interrupts, they will be prevented from accessing SPI until you call <code>SPI.endTransaction()</code>.  The SPI settings are applied at the <strong>begin</strong> of the transaction and <code>SPI.endTransaction()</code> <strong>doesn't change</strong> SPI settings. <strong>Unless</strong> you, or some library, <strong>calls</strong> beginTransaction a second time, the setting are <strong>maintained</strong>.  You should attempt to minimize the time between before you call <code>SPI.endTransaction()</code>, for best compatibility if your program is used together with other libraries which use SPI.
</p>
<p class="vspace"></p><p>With most SPI devices, after <code>SPI.beginTransaction()</code>, you will write the slave select pin LOW, call <code>SPI.transfer()</code> any number of times to transfer data, then write the SS pin HIGH, and finally call <code>SPI.endTransaction()</code>.
</p>
<p class="vspace"></p><p>For more on SPI, see <a class="urllink" href="http://en.wikipedia.org/wiki/Serial_Peripheral_Interface_Bus#Mode_Numbers" rel="nofollow" target="_blank">Wikipedia's page on SPI</a>.
</p>
<p class="vspace"></p><h3>Connections </h3>
<p>The following table display on which pins the SPI lines are broken out on the different Arduino boards:
</p>
<p class="vspace"></p>
<table style="border-collapse:collapse" cellpadding="5" border="1" width="90%"><tbody><tr><td align="center"><strong>Arduino / Genuino Board</strong></td><td align="center"><strong>MOSI</strong></td><td align="center"><strong>MISO</strong></td><td align="center"><strong>SCK</strong></td><td align="center"><strong>SS (slave)</strong></td><td align="center"><strong>SS (master)</strong></td><td align="right"><strong>  Level  </strong></td></tr>
<tr><td align="left">Uno or Duemilanove</td><td align="center">11 or ICSP-4</td><td align="center">12 or ICSP-1</td><td align="center">13 or ICSP-3</td><td align="center">10</td><td align="center">-</td><td>5V</td></tr>
<tr><td align="left">Mega1280 or Mega2560</td><td align="center">51 or ICSP-4</td><td align="center">50 or ICSP-1</td><td align="center">52 or ICSP-3</td><td align="center">53</td><td align="center">-</td><td>5V</td></tr>
<tr><td align="left">Leonardo</td><td align="center">ICSP-4</td><td align="center">ICSP-1</td><td align="center">ICSP-3</td><td align="center">-</td><td align="center">-</td><td>5V</td></tr>
<tr><td align="left">Due</td><td align="center">ICSP-4</td><td align="center">ICSP-1</td><td align="left">ICSP-3</td><td align="center">-</td><td align="center">4, 10, 52</td><td>3,3V</td></tr>
<tr><td align="left">Zero</td><td align="center">ICSP-4</td><td align="center">ICSP-1</td><td align="left">ICSP-3</td><td align="center">-</td><td align="center">-</td><td>3,3V</td></tr>
<tr><td align="left">101</td><td align="center">11 or ICSP-4</td><td align="left">12 or ICSP-1</td><td align="center">13 or ICSP-3</td><td align="center">10</td><td align="center">10</td><td>3,3V</td></tr>
<tr><td><span class="wikiword">MKR1000</span></td><td align="center">8</td><td align="center">10</td><td align="center">9</td><td align="center">-</td><td align="center">-</td><td>3,3V</td></tr>
</tbody></table>
<p class="vspace"></p><p>Note that MISO, MOSI, and SCK are available in a
 consistent physical location on the ICSP header; this is useful, for 
example, in designing a shield that works on every board.  
</p>
<p class="vspace"></p><div><img src="Arduino%20-%20SPI_files/ICSPHeader.jpg" alt="" title=""></div>
<p class="vspace"></p><h4>Note about Slave Select (SS) pin on AVR based boards</h4>
<p>All AVR based boards have an SS pin that is useful when they act as a <strong>slave</strong>
 controlled by an external master. Since this library supports only 
master mode, this pin should be set always as OUTPUT otherwise the SPI 
interface could be put automatically into slave mode by hardware, 
rendering the library inoperative.
</p>
<p class="vspace"></p><p>It is, however, possible to use any pin as the 
Slave Select (SS) for the devices. For example, the Arduino Ethernet 
shield uses pin 4 to control the SPI connection to the on-board SD card,
 and pin 10 to control the connection to the Ethernet controller. 
</p>
<p class="vspace"></p><h3>Examples</h3>
<p>
</p><ul class="secondary-list">
              <li><a href="https://www.arduino.cc/en/Tutorial/BarometricPressureSensor">Barometric Pressure Sensor</a>: Read air pressure and temperature from a sensor using the SPI protocol.</li>
              <li><a href="https://www.arduino.cc/en/Tutorial/DigitalPotControl">Digital Pot Control</a>: Control a AD5206 digital potentiometer using the SPI protocol.</li>
            </ul>

<p></p>
<p class="vspace"></p></td><td valign="top" width="35%">
<p class="vspace"></p><h4>Functions</h4>
<ul><li><a class="wikilink" href="https://www.arduino.cc/en/Reference/SPISettings">SPISettings</a>
</li><li><a class="wikilink" href="https://www.arduino.cc/en/Reference/SPIBegin">begin</a>()
</li><li><a class="wikilink" href="https://www.arduino.cc/en/Reference/SPIEnd">end</a>()
</li><li><a class="wikilink" href="https://www.arduino.cc/en/Reference/SPIbeginTransaction">beginTransaction</a>()
</li><li><a class="wikilink" href="https://www.arduino.cc/en/Reference/SPIendTransaction">endTransaction</a>()
</li><li><a class="wikilink" href="https://www.arduino.cc/en/Reference/SPISetBitOrder">setBitOrder</a>()
</li><li><a class="wikilink" href="https://www.arduino.cc/en/Reference/SPISetClockDivider">setClockDivider</a>()
</li><li><a class="wikilink" href="https://www.arduino.cc/en/Reference/SPISetDataMode">setDataMode</a>()
</li><li><a class="wikilink" href="https://www.arduino.cc/en/Reference/SPITransfer">transfer</a>()
</li><li><a class="wikilink" href="https://www.arduino.cc/en/Reference/SPIusingInterrupt">usingInterrupt</a>()
<p class="vspace"></p></li><li><a class="wikilink" href="https://www.arduino.cc/en/Reference/DueExtendedSPI">Due Extended SPI usage</a>
</li></ul><p class="vspace"></p><h4>See also</h4>
<ul><li><a class="wikilink" href="https://www.arduino.cc/en/Reference/ShiftOut">shiftOut()</a>
</li><li><a class="wikilink" href="https://www.arduino.cc/en/Reference/ShiftIn">shiftIn()</a>
</li></ul><p class="vspace"></p></td></tr></tbody></table>
<p><a class="wikilink" href="https://www.arduino.cc/en/Reference/HomePage">Reference Home</a>
</p>
<p class="vspace"></p><p><em>Corrections, suggestions, and new documentation should be posted to the <a class="urllink" href="http://arduino.cc/forum/index.php/board,23.0.html" rel="nofollow">Forum</a>.</em>
</p>
<p class="vspace"></p><p>The text of the Arduino reference is licensed under a
<a class="urllink" href="http://creativecommons.org/licenses/by-sa/3.0/" rel="nofollow" target="_blank">Creative Commons Attribution-ShareAlike 3.0 License</a>.  Code samples in the reference are released into the public domain.
</p>
</div>

				
				<!-- AddThis Button Style BEGIN -->
<style>
  .addthis_toolbox {
    margin: 2em 0 1em;
  }
  .addthis_toolbox img {
    float: left;
    height: 25px;
    margin-right: 10px;
    width: auto;
  }
  .addthis_toolbox .social-container {
    float: left;
    height: 27px; 
    width: auto; 
  }
  .addthis_toolbox .social-container .social-content {
    float: left;
    margin-top: 2px;
    max-width: 0;
    overflow: hidden;
    -moz-transition: max-width .3s ease-out;
    -webkit-transition: max-width .3s ease-out;
    -o-transition: max-width .3s ease-out;
    transition: max-width .3s ease-out;
  }
  .addthis_toolbox .social-container:hover .social-content {
    max-width: 100px;
    -moz-transition: max-width .2s ease-in;
    -webkit-transition: max-width .2s ease-in;
    -o-transition: max-width .2s ease-in;
    transition: max-width .2s ease-in;
  }
  .addthis_toolbox .social-container .social-content a {
    float: left;
    margin-right: 5px;
  }

  .addthis_toolbox h3 {
    font-size: 24px;
    text-align: left;
  }
</style>
<!-- AddThis Button Style END -->
<!-- AddThis Button BEGIN -->
<div class="addthis_toolbox addthis_default_style">
  <h3>Share</h3>
  <!-- FACEBOOK -->
  <div class="social-container">
    <img src="Arduino%20-%20SPI_files/facebook_002.png">
    <div class="social-content">
      <a class="addthis_button_facebook_like" fb:like:layout="button_count"></a>
    </div>
  </div>
  <!-- TWITTER -->
  <div class="social-container">
    <img src="Arduino%20-%20SPI_files/twitter_002.png">
    <div class="social-content">
      <a class="addthis_button_tweet"></a>
    </div>
  </div>
  <!-- PINTEREST -->
  <div class="social-container">
    <img src="Arduino%20-%20SPI_files/pinterest.png">
    <div class="social-content">
      <a class="addthis_button_pinterest_pinit" pi:pinit:url="//www.addthis.com/features/pinterest" pi:pinit:media="//www.addthis.com/cms-content/images/features/pinterest-lg.png"></a>
    </div>
  </div>
  <!-- G+ -->
  <div class="social-container">
    <img src="Arduino%20-%20SPI_files/gplus.png">
    <div class="social-content">
      <a class="addthis_button_google_plusone" g:plusone:size="medium"></a>
    </div>
  </div>

  <script type="text/javascript">var addthis_config = {"data_track_addressbar":false};</script>
  <script type="text/javascript" src="Arduino%20-%20SPI_files/addthis_widget.js"></script>
</div>
<!-- AddThis Button END -->

		</div> <!-- eof pagetext -->
	
	</div> <!-- eof page -->
		
	<!--PageFooterFmt-->
	<div id="pagefooter">
		<div id="newsletterModal" class="reveal-modal small">
  <form action="https://www.arduino.cc/subscribe.php" method="post" name="sendy-subscribe-form" id="sendy-subscribe-form" class="form-popup">
    <div class="modalHeader">
      <h3 style="line-height: 1.8rem;" class="modal-header-alt">This link has expired. <br>Please re-subscribe to our Newsletters.</h3>
      <h3 class="modal-header-main">Subscribe to our Newsletters</h3>
    </div>
    <div class="modalBody" id="newsletterModalBody">
        <div id="newsletterEmailField" class="row" style="padding-left: 0">
          <div class="large-2 columns">
            <label for="email" class="newsletter-form-label inline">Email</label>
          </div>
          <div class="large-10 columns" style="padding-left: 0">
            <input placeholder="Enter your email address" name="email" class="subscribe-form-input" type="email">
            <p id="emailMissing" class="newsletterPopupError">Please enter a valid email to subscribe</p>
          </div>
        </div>
        <div style="margin-left:20px">
          <div style="margin-bottom:0.3em">
            <input style="display:none" checked="checked" name="list[]" value="arduino_newsletter_id" id="worldwide" class="newsletter-form-checkbox" type="checkbox">
            <label for="worldwide"></label>
            <div style="display:inline-block" class="newsletter-form-label">Arduino Newsletter</div>
          </div>
          <div style="margin-bottom:0.3em">
            <input style="display:none" checked="checked" name="list[]" value="arduino_store_newsletter_id" id="store" class="newsletter-form-checkbox" type="checkbox">
            <label for="store"></label>
            <div style="display:inline-block" class="newsletter-form-label">Arduino Store Newsletter</div>
          </div>
          <div>
            <input style="display:none" name="list[]" value="arduino_italians_newsletter_id" id="italians" class="newsletter-form-checkbox" type="checkbox">
            <label for="italians"></label>
            <div style="display:inline-block" class="newsletter-form-label">Newsletter Italiana</div>
          </div>
        </div>
        <div>
          <p class="newsletterPopupError2" id="newsletterSubscribeStatus"></p>
        </div>
    </div>
    <div class="row modalFooter">
      <div class="form-buttons-row">
        
          <button type="button" value="Cancel" class="popup-form-button white cancel-modal close-reveal-modal">Cancel</button>
          <button type="submit" name="Subscribe" id="subscribe-submit-btn" class="popup-form-button">Next</button>
        
      </div>
    </div>
  </form>

  <!-- step 2, confirm popup -->
  <div class="confirm-popup" style="margin-bottom:1em">
    <div class="modalHeader">
      <h3>Confirm your email address</h3>
    </div>
    <div class="modalBody" id="newsletterModalBody" style="padding-right:1em;margin-bottom:0">
        <p style="margin-bottom:1em;font-size:15px">
          We need to confirm your email address.<br>
          To complete the subscription, please click the link in the
          email we just sent you.
        </p>
        <p style="margin-bottom:1em;font-size:15px">
          Thank you for subscribing!
        </p>
        <p style="margin-bottom:1em;font-size:15px">
          Arduino<br>
          via Egeo 16<br>
          Torino, 10131<br>
          Italy<br>
        </p>
    </div>
    <div class="row modalFooter">
      <div class="form-buttons-row">
        
          <button name="Ok" class="popup-form-button" id="close-confirm-popup">Ok</button>

      </div>
    </div>
  </div>

</div>
<div id="pagefooter" class="pagefooter">
  <div class="row">
    <div class="large-8 eight columns">
      <div class="large-4 four columns newsletter-box">
        <!-- Begin Sendy Signup Form -->
        <h6>Newsletter</h6>
        <div>
          <input name="email" class="email" id="sendy-EMAIL" placeholder="Enter your email to sign up" type="email">
          <i class="icon-right-small"></i>
          <input value="Subscribe" name="subscribe" id="sendy-subscribe" class="newsletter-button">
        </div>
        <!--End sendy_embed_signup-->
      </div>
      <div class="clearfix"></div>
      <ul class="inline-list">
        <li class="monospace">©2017 Arduino AG</li>
        <li><a href="https://www.arduino.cc/en/Main/CopyrightNotice">Trademarks</a></li>
        <li><a href="https://www.arduino.cc/en/Main/ContactUs">Contact us</a></li>
        <li><a href="https://www.arduino.cc/en/Main/AboutUs">About us</a></li>
        <li><a href="https://www.arduino.cc/Careers">Careers</a></li>
      </ul>
    </div>
    <div class="large-4 four columns">
      <ul id="arduinoSocialLinks" class="arduino-social-links">
        <li>
          <a href="https://twitter.com/arduino" target="_blank">
            <img src="Arduino%20-%20SPI_files/twitter.png">
          </a>
        </li>
        <li>
          <a href="https://www.facebook.com/official.arduino" target="_blank">
            <img src="Arduino%20-%20SPI_files/facebook.png">
          </a>
        </li>
        <li>
          <a href="https://plus.google.com/+Arduino" target="_blank">
            <img src="Arduino%20-%20SPI_files/gplus_002.png">
          </a>
        </li>
        <li>
          <a href="https://www.flickr.com/photos/arduino_cc" target="_blank">
            <img src="Arduino%20-%20SPI_files/flickr.png">
          </a>
        </li>
        <li>
          <a href="https://youtube.com/arduinoteam" target="_blank">
            <img src="Arduino%20-%20SPI_files/youtube.png">
          </a>
        </li>
      </ul>
    </div>
  </div>
</div>

	</div>
	<!--/PageFooterFmt-->
	
	<!--[if gte IE 9]><!-->
	<script src="Arduino%20-%20SPI_files/foundation_002.js"></script>
	<script src="Arduino%20-%20SPI_files/foundation.js"></script>
	<script>
	  $(document).foundation();
	</script>
	<!--<![endif]-->
	<!--[if IE 8]>
	<script src="//arduino.cc/js/foundation_ie8.min.js"></script>
	<script src="//arduino.cc/js/ie8/jquery.foundation.orbit.js"></script>
	<script src="//arduino.cc/js/ie8/jquery.foundation.alerts.js"></script>
	<script src="//arduino.cc/js/app.js"></script>
	
	<script>
	$(window).load(function(){
	  $("#featured").orbit();
	});
	</script>
	<![endif]-->
	
	<script type="text/javascript">
	  var _gaq = _gaq || [];
	  _gaq.push(['_setAccount', 'UA-22581631-3']);
	  _gaq.push(['_setDomainName', 'arduino.cc']);
	  _gaq.push(['_trackPageview']);
	
	    (function() {
	    var ga = document.createElement('script'); ga.type = 'text/javascript'; ga.async = true;
	    ga.src = ('https:' == document.location.protocol ? 'https://ssl' : 'http://www') + '.google-analytics.com/ga.js';
	    var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(ga, s);
	  })();
	</script>

	<script>
	  $(window).load(function(){
	    $('a').each (function () {
	      href = $(this).attr ('href');
	      if (href !== undefined && href.substring (0, 4) == 'http' && href.indexOf ('arduino.cc') == -1)
	        $(this).attr ('target', '_blank');
	    });

	    // js for language dropdown
	    $('.language-dropdown .current').on('click', function(e){
          e.stopPropagation();
          $('.language-dropdown ul').toggle();
        });

        $('.language-dropdown .selector').on('click', function(e){
          e.stopPropagation();
          $('.language-dropdown ul').toggle();
        });

        $(document).on('click', function(){
          $('.language-dropdown ul:visible').hide();  
        });

        $('.language-dropdown li a').on('click', function(e){
        	$('.language-dropdown .current').text($(this).text());
        });

        //js for product pages navbar
        var menu = $(".product-page-nav");
	    var menuItems = menu.find("a");
	    var timeoutId = null;
	    var limitTop = 600;

	    var menuOffset = $('.product-page-nav li').first().offset();
	    if(menuOffset) {
	    	limitTop = menuOffset.top;
	    }
	    var limitBottom = $('.addthis_toolbox').offset().top;

	    var activateSection = function($sectionToActivate) {
	      var label=$sectionToActivate.attr('label');

	      $(".product-page-nav").find('li').removeClass('active');
	      $sectionToActivate.addClass('active');
	    };

	    menuItems.click(function(e){

	     e.preventDefault();
	      var href = $(this).attr("href"),
	          offsetTop = href === "#" ? 0 : $(href).offset().top,
	          adjust = 0;
	      if($(this).parent('li').hasClass('active') === false) {

	          adjust = 80;

	          $('html, body').animate({
	                scrollTop: offsetTop - adjust
	            }, 1500, 'easeOutExpo');

	      }
	    });

	    $(window).scroll(function () {

	      var windscroll = $(window).scrollTop();

	      if(windscroll < limitTop) {
	        $('.menu').removeClass('sticky');
	        $('.menu').removeClass('fixed');
	      }  else {
	        $('.menu').addClass('sticky');
	      }

	      var menuEdgeBottomOffset = $('.menu.columns').offset();
	      var menuEdgeBottom = 0;
	      if(menuEdgeBottomOffset) {
	      	menuEdgeBottom = menuEdgeBottomOffset.top + $('.menu.columns').height();
	      }
	      if(menuEdgeBottom > limitBottom) {
	        $('.menu').fadeOut();
	      } else {
	        $('.menu').fadeIn();
	      }
	      menuItems.each(function(i) {
	        var href = $(this).attr("href");
	        if ($(href).offset().top <= windscroll + 150) {
	          if(timeoutId) {
	            clearTimeout(timeoutId);
	          }
	          timeoutId = setTimeout(activateSection, 60, $(".product-page-nav").find('li').eq(i));
	        }
	      });

	    });

	  });
	
		//Facebook Pixel Code
		!function(f,b,e,v,n,t,s){if(f.fbq)return;n=f.fbq=function(){n.callMethod?
		n.callMethod.apply(n,arguments):n.queue.push(arguments)};if(!f._fbq)f._fbq=n;
		n.push=n;n.loaded=!0;n.version='2.0';n.queue=[];t=b.createElement(e);t.async=!0;
		t.src=v;s=b.getElementsByTagName(e)[0];s.parentNode.insertBefore(t,s)}(window,
		document,'script','https://connect.facebook.net/en_US/fbevents.js');

		fbq('init', '1205220922863531');
		fbq('track', "PageView");
		
	</script>

	<noscript><img height="1" width="1" style="display:none" src="https://www.facebook.com/tr?id=1205220922863531&ev=PageView&noscript=1"/></noscript>
	<!-- End Facebook Pixel Code -->


<div id="fb-root" class=" fb_reset"><div style="position: absolute; top: -10000px; height: 0px; width: 0px;"><div><iframe name="fb_xdm_frame_https" allowtransparency="true" allowfullscreen="true" scrolling="no" id="fb_xdm_frame_https" aria-hidden="true" title="Facebook Cross Domain Communication Frame" tabindex="-1" style="border: medium none;" src="https://staticxx.facebook.com/connect/xd_arbiter/r/ao6eUeuGXQq.js?version=42#channel=f358f2104d54b9c&amp;origin=https%3A%2F%2Fwww.arduino.cc" frameborder="0"></iframe></div></div><div style="position: absolute; top: -10000px; height: 0px; width: 0px;"><div></div></div></div><iframe allowtransparency="true" style="z-index: 2147483647; display: none; background: rgba(0, 0, 0, 0.004) none repeat scroll 0% 0%; border: 0px none transparent; overflow-x: hidden; overflow-y: auto; visibility: visible; margin: 0px; padding: 0px; position: fixed; left: 0px; top: 0px; width: 100%; height: 100%;" src="Arduino%20-%20SPI_files/index-8fc522188368beac280286295c6b1a74.htm" name="stripe_checkout_app" class="stripe_checkout_app" frameborder="0"></iframe></body></html>